/* -*- mode: C++ ; c-file-style: "stroustrup" -*- *****************************
 * Qwt Widget Library
 * Copyright (C) 1997   Josef Wilgen
 * Copyright (C) 2002   Uwe Rathmann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the Qwt License, Version 1.0
 *****************************************************************************/

#ifndef QWT_LEGEND_ITEM_H
#define QWT_LEGEND_ITEM_H


#include "qwt_legend.h"
#include "qwt_text.h"
#include "qwt_text_label.h"
#include <qpixmap.h>

/*!
  \brief A widget representing something on a QwtLegend().
*/
class QwtLegendItem: public QwtTextLabel
{
    Q_OBJECT
public:
    explicit QwtLegendItem( QWidget *parent = 0 );
    virtual ~QwtLegendItem();

    void setSpacing( int spacing );
    int spacing() const;

    virtual void setText( const QwtText & );

    void setIdentifier( const QPixmap & );
    QPixmap identifier() const;

    void setIdentifierSize( const QSize & );
    QSize identifierSize() const;

    virtual QSize sizeHint() const;

protected:
    virtual void paintEvent( QPaintEvent * );

private:
    class PrivateData;
    PrivateData *d_data;
};

#endif 
