/* -*- mode: C++ ; c-file-style: "stroustrup" -*- *****************************
 * Qwt Widget Library
 * Copyright (C) 1997   Josef Wilgen
 * Copyright (C) 2003   Uwe Rathmann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the Qwt License, Version 1.0
 *****************************************************************************/

#ifndef QWT_TEXT_ENGINE_H
#define QWT_TEXT_ENGINE_H 1


#include <qsize.h>

class QFont;
class QRectF;
class QString;
class QPainter;

/*!
  \brief A text engine for plain texts

  QwtPlainTextEngine renders texts using the basic Qt classes
  QPainter and QFontMetrics.
*/
class QwtPlainTextEngine
{
public:
    static double heightForWidth( const QFont &font, int flags,
        const QString &text, double width );

    static QSizeF textSize( const QFont &font, int flags,
        const QString &text );

    static void draw( QPainter *painter, const QRectF &rect,
        int flags, const QString &text );

    static void textMargins( const QFont &, const QString &,
        double &left, double &right, double &top, double &bottom );
};

#endif
