#ifndef CONTAINER_BASETYPES_H
#define CONTAINER_BASETYPES_H

#include <2d/plot_2dtypes.h>
#include <3d/plot_3dtypes.h>
#include "ccd/ccd.h"

class TAbstractInfo
{
public:
    enum TypeOfInfo {Blank, _2d, _3d, _4d};

    void *Info;
    int InfoType;
    plot::TMetaStorage attributes;
    bool UpdatePreview;

    TAbstractInfo(void *SrcInfo = 0, int Type = TAbstractInfo::Blank) {
        UpdatePreview = false;
        Info = SrcInfo;
        InfoType = Type;
    }

    TAbstractInfo(int Type) {
        UpdatePreview = false;
        InfoType = Type;

        if (Type == _2d)
            Info = new plot::TCurvesDataOwner;
        else if (Type == _3d)
            Info = new plot::T3dDataOwner;
        else if (Type == _4d)
            Info = new ccd::TSetOfSpectrum;
        else Info = 0;
    }
};

typedef QVector<TAbstractInfo> TAbstractInfos;

#endif // CONTAINER_BASETYPES_H
