#include "control3030.hpp"
#include "mainwindow.h"
#include <QSettings>
#include <QTimer>
#include <QApplication>

Control3030::Control3030()
{
    ftHandle = NULL;
    m_closeThread = false;
    m_waitMainInit = true;

    prevStatus = -1;
    deviceStatus = new StatusWidget1(tr("USB") + " 2");
    deviceStatus->label->setToolTip(tr("EG-1000"));
    setDeviceStatus(EDno);
    connect(this, SIGNAL(usbStatus(int)), this, SLOT(setDeviceStatus(int)), Qt::QueuedConnection);

    for (int i = 0; i < 4; i++)
        Active_Ch[i] = 0;

    Packet_Recieved=false;

    Action_1 = false;
    Action_2 = false;
    Action_3 = false;
    Action_5 = false;
    Action_6 = false;
    Action_61 = false;
    Action_62 = false;
    Action_63 = false;
    Action_64 = false;
    Action_65 = false;
    Action_7 = false;
    Action_71 = false;
    Action_72 = false;
    Action_73 = false;
    Action_75 = false;
    Action_76 = false;
    Action_77 = false;
    Action_78 = false;
    Action_79 = false;

    Action_8 = false;
    Action_81 = false;
    Action_82 = false;
    Action_83 = false;
    Action_84 = false;
    Action_85 = false;
    Action_86 = false;
    Action_87 = false;
    Action_88 = false;
    Action_89 = false;
    Action_9 = false;
    Action_10 = false;
    Action_11 = false;
    Action_13 = false;
    Action_15 = false;
    Action_16 = false;
    Action_17 = false;
    Action_18 = false;
    Action_19 = false;
    Action_20 = false;
    Action_21 = false;
    Action_22 = false;
    Action_23 = false;

    QSettings settings("Param/controller.conf", QSettings::IniFormat);
    csb_speed_idx = qMin(3, settings.value("csb_speed_settings_idx", 1).toInt());

    Xsp=0; Ysp=0; Zsp=0;
    Xsp2=0;Ysp2=0;Zsp2=0;

    eg3000_init_read_handle(&read_handle);
}

Control3030::~Control3030()
{
    terminate();
    eg3000_close_read_handle(&read_handle);
}

void Control3030::setDeviceStatus(int idx)
{
    if (prevStatus == idx)
        return;
    prevStatus = idx;

    if (!deviceStatus)
        return;

    switch (idx) {
    case EDno:
        deviceStatus->status->set(StatusWidget::Cross, Qt::red);
        deviceStatus->status->setToolTip(tr("No device"));
        break;
    case EDconn:
        deviceStatus->status->set(StatusWidget::Circle, QColor(255, 128, 0));
        deviceStatus->status->setToolTip(tr("Loading"));
        break;
    case EDok:
        deviceStatus->status->set(StatusWidget::Circle, Qt::green);
        deviceStatus->status->setToolTip(tr("Connected"));
        break;
    }
}

void Control3030::thread_close()
{
    m_closeThread = true;

    while (isRunning()) {
        qApp->processEvents();
        msleep(3);
    }
}

void Control3030::Set_Scanner_Data(float* scanner_data_pid_cal_range, DWORD *scanner_data_scale, long* scanner_data_Time,
                                   bool* nlc_c_xy, bool* ncl_xy, bool* nlc_c_z, bool* ncl_z,
                                   bool* nlc_o_xy, bool* nlc_o_z, float *_free_move_speed,
                                   float* scanner2_data_pid_cal_range, DWORD *scanner2_data_scale, long* scanner2_data_Time,
                                   bool* nlc2_c_xy, bool* ncl2_xy, bool* nlc2_c_z, bool* ncl2_z,
                                   bool* nlc2_o_xy, bool* nlc2_o_z, float *_free_move_speed2)
{
    Scanner_data_pid_cal_range = scanner_data_pid_cal_range;
    Scanner_data_scale = scanner_data_scale;
    Scanner_data_Shift = scanner_data_Time;

    Nlc_status_cl_xy = nlc_c_xy;
    CL_status_xy = ncl_xy;
    Nlc_status_cl_z = nlc_c_z;
    CL_status_z = ncl_z;
    Nlc_status_ol_xy = nlc_o_xy;
    Nlc_status_ol_z = nlc_o_z;

    free_move_speed = _free_move_speed;

    Scanner2_data_pid_cal_range = scanner2_data_pid_cal_range;
    Scanner2_data_scale = scanner2_data_scale;
    Scanner2_data_Shift = scanner2_data_Time;

    Nlc_status_cl_xy2 = nlc2_c_xy;
    CL_status_xy2 = ncl2_xy;
    Nlc_status_cl_z2 = nlc2_c_z;
    CL_status_z2 = ncl2_z;
    Nlc_status_ol_xy2 = nlc2_o_xy;
    Nlc_status_ol_z2 = nlc2_o_z;

    free_move_speed2 = _free_move_speed2;
}
void Control3030::SetExtraCalibOut(double *adcCalib_p, double *dacCalib_p)
{
    adcCalib = adcCalib_p;
    dacCalib = dacCalib_p;
}

void Control3030::Usb_Load_Data()
{
    Action_1 = true;
}
void Control3030::Data_to_Cont()
{
    Action_2 = true;
}
void Control3030::Save_to_EEPROM(void)
{
    Action_3 = true;
}
void Control3030::SendExtraCalib()
{
    Action_22=true;
}
void Control3030::sl_csb_speed(int idx)
{
    csb_speed_idx = idx;
    Action_23 = true;
}
void Control3030::Set_osc_Channel(int idx, int ch)
{
    Active_Ch[idx] = ch;
    Action_9 = true;
}
void Control3030::Go_to_XYZ(double Xsp_n, double Ysp_n, double Zsp_n)
{
    Xsp = Xsp_n;
    Ysp = Ysp_n;
    Zsp = Zsp_n;

    emit xUpdate(Xsp);
    emit yUpdate(Ysp);
    emit zUpdate(Zsp);
    scanner=scHead;
    Action_5 = true;
}
void Control3030::Go_to_XYZ2(double Xsp_n, double Ysp_n, double Zsp_n)
{
    Xsp2 = Xsp_n;
    Ysp2 = Ysp_n;
    Zsp2 = Zsp_n;

    emit x2Update(Xsp2);
    emit y2Update(Ysp2);
    emit z2Update(Zsp2);
    scanner=scStage;
    Action_5 = true;
}
void Control3030::Go_to_Zobject(double Zsp_n)
{
    Zsp2 = Zsp_n;
    emit z2Update(Zsp2);
    scanner=scStage;
    Action_5 = true;
}
void Control3030::Go_to_Xobject(double Xsp_n)
{
    Xsp2 = Xsp_n;
    emit x2Update(Xsp2);
    scanner=scStage;
    Action_5 = true;
}
void Control3030::Go_to_Yobject(double Ysp_n)
{
    Ysp2 = Ysp_n;
    emit y2Update(Ysp2);
    scanner=scStage;
    Action_5 = true;
}

void **_ftHandle;

void Control3030::SetTestMode(bool value)
{
    testMode=value;
    deviceStatus->setEmulator(value);
}

void Control3030::s_boot_timeout()
{
    boot_timeout = true;
}

extern QMutex *ftdi_mutex;
bool eg_open_small(WORD vid, WORD pid) {
    WORD size;
    bool st;

    QMutexLocker locker(ftdi_mutex);
    st = eg3000_get_number(vid, pid, &size);
    if (!st || size == 0)
        return false;

    struct s_info *array;
    try {
        array = new struct s_info[size];
    } catch (...) {
        qDebug() << "eg_open_small new exception";
        return false;
    }

    st = eg3000_list(vid, pid, &size, array, size);
    if (st && size != 0) {
        st = false; //not found
        for (int i = 0; i < size; i++) {
            if (array[i].flags & F_EG1000) {
                st = eg3000_open(array[i].handle, vid, pid, _ftHandle);
                break;
            }
        }
    }

    delete [] array;
    return st;
}

void Control3030::run()
{
    _ftHandle = &ftHandle;

    m_closeThread = false;
    m_waitMainInit = true;

    if (testMode) {
        while (m_waitMainInit && !m_closeThread) {
            msleep(50);
        }

        emit updateUsbStatus(true);
        emit usbStatus(EDok);

        while (!m_closeThread) {
            msleep(50);
        }

        return;
    }

    boot_timeout_t = new QTimer();
    boot_timeout_t->setInterval(2500);
    boot_timeout_t->setSingleShot(true);
    connect(boot_timeout_t, SIGNAL(timeout()), this, SLOT(s_boot_timeout()), Qt::QueuedConnection);
    connect(this, SIGNAL(restart_boot_timer()), boot_timeout_t, SLOT(start()), Qt::QueuedConnection);
    connect(this, SIGNAL(destroyed()), boot_timeout_t, SLOT(stop()), Qt::QueuedConnection);
    connect(this, SIGNAL(destroyed()), boot_timeout_t, SLOT(deleteLater()), Qt::QueuedConnection);
    boot_timeout_t->moveToThread(qApp->thread());

    st = false;

    bool need_boot = true;
    bool is_flash_good = true;

    boot_timeout = false;
    BYTE boot_timeout_count = 0;

#ifndef _NO_FTDI
    bool use_4000 = false;
#else
    bool use_4000 = true;
#endif

    while (!m_closeThread) {
        if (st) st = eg3000_is_ok(ftHandle);

        if (st && need_boot) {
            eg3000_bl_stats(ftHandle); //ping bootloader
            eg3000_cpu_loopback(ftHandle); //ping cpu
            st = eg3000_is_ok(ftHandle);

            emit restart_boot_timer();
            boot_timeout = false;
            boot_timeout_count = 0;
        }
        while (st && need_boot && !m_closeThread) {
            st = eg3000_update_parse(ftHandle, &read_handle);
            Packet_Recieved = read_handle.packet_recieved;
            PacketSize = read_handle.packet_size;
            Address = read_handle.address;
            SubAddress = read_handle.sub_address;

            //packet parsing
            if (Packet_Recieved) {
                if (Address == ADR_BOOTLOADER) {
                    if (SubAddress == BL_ERROR) {
                        qDebug() << "bl error" << (void*)((BYTE *)read_handle.buffer)[0];
                    }
                    if (SubAddress == BL_STATS) {
                        //unsigned int flash_size = ((DWORD*)read_handle.buffer)[0];
                        is_flash_good = ((BYTE *)read_handle.buffer)[4];

                        if (!is_flash_good) {
                            qDebug() << "no flash in controller!";
                            emit no_firmware();
                        } else //auto_boot
                            st = eg3000_bl_run(ftHandle);
                    }

                    if (SubAddress == BL_BOOT_OK) { //booted
                        st = eg3000_cpu_loopback(ftHandle); //ping
                    }
                }
                if (Address == ADR_CPU) {
                    need_boot = false;
                }

                eg3000_discard_packet(&read_handle);
            } else
                msleep(10);

            if (st && boot_timeout && need_boot && !m_closeThread && is_flash_good) {
                emit restart_boot_timer();
                boot_timeout = false;

                //resend query
                eg3000_bl_stats(ftHandle); //ping bootloader
                eg3000_cpu_loopback(ftHandle); //ping cpu
                st = eg3000_is_ok(ftHandle);

                if (read_handle.packet_malformed)
                    eg3000_clear_read_handle(&read_handle);
                else
                    boot_timeout_count++;

                if (boot_timeout_count >= 3) {
                    qDebug() << "boot timeout";
                    emit boot_failed();
                }
            }
        }

        if (!m_waitMainInit) {
            emit updateUsbStatus(st);
            emit usbStatus(st ? (need_boot ? EDconn : EDok) : EDno);
        }

        if (!st && ftHandle != NULL) {
            eg3000_close(ftHandle);
            ftHandle = NULL;
        }

        if (!st && !m_closeThread) {
#ifndef _NO_FTDI
            QSettings settings("Param/controller.conf", QSettings::IniFormat);
            bool use = settings.value("use_eg4000", false).toBool();
            if (use_4000 != use)
                eg3000_set_backend(use ? 1 : 0); //libusb:ftdi
            use_4000 = use;
#endif

            need_boot = true;
            is_flash_good = true;

            st = eg_open_small(VID, PID+(use_4000 ? 5 : 0));

            if (st) {
                eg3000_clear(ftHandle);
                eg3000_clear_read_handle(&read_handle);

                emit sig_Osc_reset();
                eg3000_status_onoff(ftHandle, 1);
                st = eg3000_is_ok(ftHandle);
            }
        }

        if (!st || need_boot) {
            if (!st)
            for (int i = 0; i < 10 && !m_closeThread; i++)
                msleep(50);
            continue;
        }

        if (m_waitMainInit) {
            for (int i = 0; i < 2 && m_waitMainInit; i++)
                msleep(50);
            continue;
        }

        //------------------WRITE---------------------
        if (Action_1) {
            eg3000_read_caldata(ftHandle);
            Action_1 = false;
        }
        if (Action_2) {
            Action_2 = false;
            eg3000_send_caldata(ftHandle, scHead,
                                     Scanner_data_pid_cal_range, Scanner_data_scale, Scanner_data_Shift,
                                     *Nlc_status_cl_xy, *CL_status_xy, *free_move_speed,
                                     *Nlc_status_cl_z, *CL_status_z, *Nlc_status_ol_xy, *Nlc_status_ol_z);

            eg3000_send_caldata(ftHandle, scStage,
                                     Scanner2_data_pid_cal_range, Scanner2_data_scale, Scanner2_data_Shift,
                                     *Nlc_status_cl_xy2, *CL_status_xy2, *free_move_speed2,
                                     *Nlc_status_cl_z2, *CL_status_z2, *Nlc_status_ol_xy2, *Nlc_status_ol_z2);
        }
        if (Action_3) {
            eg3000_save_caldata(ftHandle);
            Action_3 = false;
        }
        if (Action_5) {
            if (scanner==scHead) eg3000_set_point_xyz(ftHandle, scanner, Xsp, Ysp, Zsp);
            else                 eg3000_set_point_xyz(ftHandle, scanner, Xsp2, Ysp2, Zsp2);
            Action_5 = false;
        }
        if (Action_9) {
            eg3000_osc_set_data(ftHandle, Active_Ch[0], Active_Ch[1], Active_Ch[2], Active_Ch[3]);
            Action_9 = false;
        }
        if (Action_10) {
            eg3000_osc_startstop(ftHandle, 1);
            Action_10 = false;
        }
        if (Action_11) {
            eg3000_osc_startstop(ftHandle, 0);
            Action_11 = false;
        }
        if (Action_22) {
            eg3000_set_extra_calib(ftHandle, adcCalib, dacCalib);
            Action_22 = false;
        }
        if (Action_23) {
            BYTE data = csb_speed_idx;
            eg3000_send_packet(ftHandle, ADR_CPU, CPU_SET_CSB_RATE, &data, 1);
            Action_23 = false;
        }
        //------------------READ---------------------------
        st = eg3000_update_parse(ftHandle, &read_handle);
        Packet_Recieved = read_handle.packet_recieved;
        PacketSize = read_handle.packet_size;
        Address = read_handle.address;
        SubAddress = read_handle.sub_address;

        //packet parsing
        if (Packet_Recieved) {
            switch(SubAddress) {
            case CPU_READ_CALDATA:
                calib_data = &CD;
                memset(calib_data, 0, sizeof (EG_CalData));
                memcpy(calib_data, read_handle.buffer, qMin((DWORD)sizeof (EG_CalData), PacketSize));

                //first 48 floats in arrays
                memcpy((void *)Scanner_data_pid_cal_range, (void *)calib_data, 48*sizeof(float));

                Scanner_data_scale[0] = calib_data->CSB_Mult[0];
                Scanner_data_scale[1] = calib_data->CSB_Mult[1];
                Scanner_data_scale[2] = calib_data->CSB_Mult[2];

                Scanner_data_Shift[0] = calib_data->CSB_Shift[0]-32768;
                Scanner_data_Shift[1] = calib_data->CSB_Shift[1]-32768;
                Scanner_data_Shift[2] = calib_data->CSB_Shift[2]-32768;

                *Nlc_status_cl_xy = (bool)calib_data->NLCStatus;
                *CL_status_xy  = (bool)calib_data->CLStatus;
                *Nlc_status_cl_z = (bool)calib_data->NLCStatusZ;
                *CL_status_z  = (bool)calib_data->CLStatusZ;
                *Nlc_status_ol_xy = (bool)calib_data->NLCStatusOL;
                *Nlc_status_ol_z = (bool)calib_data->NLCStatusOLZ;
                *free_move_speed = calib_data->DefaultRateOL;

                //always in pair with next packet, update on full info
                //emit Update_EEP_Data();

                break;
            case CPU_READ_CALDATA_STAGE:
                calib_data = &CD;
                memset(calib_data, 0, sizeof (EG_CalData));
                memcpy(calib_data, read_handle.buffer, qMin((DWORD)sizeof (EG_CalData), PacketSize));

                //first 48 floats in arrays
                memcpy((void *)Scanner2_data_pid_cal_range, (void *)calib_data, 48*sizeof(float));

                Scanner2_data_scale[0] = calib_data->CSB_Mult[0];
                Scanner2_data_scale[1] = calib_data->CSB_Mult[1];
                Scanner2_data_scale[2] = calib_data->CSB_Mult[2];

                Scanner2_data_Shift[0] = calib_data->CSB_Shift[0]-32768;
                Scanner2_data_Shift[1] = calib_data->CSB_Shift[1]-32768;
                Scanner2_data_Shift[2] = calib_data->CSB_Shift[2]-32768;

                *Nlc_status_cl_xy2 = (bool)calib_data->NLCStatus;
                *CL_status_xy2  = (bool)calib_data->CLStatus;
                *Nlc_status_cl_z2 = (bool)calib_data->NLCStatusZ;
                *CL_status_z2  = (bool)calib_data->CLStatusZ;
                *Nlc_status_ol_xy2 = (bool)calib_data->NLCStatusOL;
                *Nlc_status_ol_z2 = (bool)calib_data->NLCStatusOLZ;
                *free_move_speed2 = calib_data->DefaultRateOL;

                emit Update_EEP_Data();

                break;
            case CPU_OSCDATA: {
                EG_OscData *Osc_data = (EG_OscData *)read_handle.buffer;

                int dataSize = sizeof(EG_OscData) - (OSC_LINE_SIZE - Osc_data->Size)*sizeof(WORD);
                emit OscCurveData(QByteArray((char *)Osc_data, dataSize));
            }
                break;                
            case CPU_STATUS:
                Deflectomter = (EG_Status *)read_handle.buffer;

                bool scanError = (Deflectomter->ErrorCode & ecScanErrorPID);
                //bool headConnected = !(Deflectomter->ErrorCode & ecHeadNotFound);
                //bool stageConnected = !(Deflectomter->ErrorCode & ecStageNotFound);

                if (!scanError && (Deflectomter->ErrorCode & ecAxisErrorPID))
                    emit sigSetpointError(0+2);
                if (!scanError && (Deflectomter->ErrorCode & ecAxisErrorPID2))
                    emit sigSetpointError(1+2);

                emit usbStatus(Deflectomter->Scanning != mdIdle ? EDplay : EDok);

                break;
            }

            eg3000_discard_packet(&read_handle);
        }

        msleep(10);
    }

    if (ftHandle != NULL) {
        eg3000_close(ftHandle);
        ftHandle = NULL;
    }
}

void Control3030::Osc_Start()
{
    Action_10 = true;
}
void Control3030::Osc_Stop()
{
    Action_11 = true;
}
