#ifndef CONTROL3030_HPP
#define CONTROL3030_HPP

#include <QThread>
#include <QPointer>
#include "plot.h"
#include "i_eg3000.h"

class StatusWidget1;
class Control3030 : public QThread
{
    Q_OBJECT
public:
    Control3030();
    ~Control3030();
    void run();
    void SetTestMode(bool);

    QPointer<StatusWidget1> deviceStatus;
    int prevStatus;

    void *ftHandle;
    struct eg3000_read_handle read_handle;

    EG_Status *Deflectomter;
    EG_CalData CD;
    EG_CalData *calib_data;
    bool st;
    bool testMode;
    bool m_closeThread;
    bool m_waitMainInit;

    bool Packet_Recieved;
    BYTE Address;
    BYTE SubAddress;
    DWORD PacketSize;

    int Active_Ch[4];
    int scanner;
    int csb_speed_idx;

    bool Action_1, Action_2, Action_3, Action_5, Action_6,
    Action_61, Action_62, Action_63, Action_64, Action_65, Action_7,
    Action_71, Action_72, Action_73, Action_75, Action_76, Action_77,
    Action_78, Action_79, Action_8, Action_81, Action_82, Action_83,
    Action_84, Action_85, Action_86, Action_87, Action_88, Action_89,
    Action_9, Action_10,Action_11, Action_13,
    Action_15, Action_16, Action_17, Action_18, Action_19, Action_20,
    Action_21, Action_22, Action_23;

    double Xsp, Ysp, Zsp;
    double Xsp2, Ysp2, Zsp2;

    //head
    float *Scanner_data_pid_cal_range;
    DWORD *Scanner_data_scale;
    long *Scanner_data_Shift;

    bool *Nlc_status_cl_xy;
    bool *CL_status_xy;
    bool *Nlc_status_cl_z;
    bool *CL_status_z;
    bool *Nlc_status_ol_xy;
    bool *Nlc_status_ol_z;

    float *free_move_speed;

    //stage
    float *Scanner2_data_pid_cal_range;
    DWORD *Scanner2_data_scale;
    long *Scanner2_data_Shift;

    bool *Nlc_status_cl_xy2;
    bool *CL_status_xy2;
    bool *Nlc_status_cl_z2;
    bool *CL_status_z2;
    bool *Nlc_status_ol_xy2;
    bool *Nlc_status_ol_z2;

    float *free_move_speed2;

    void Set_Scanner_Data(float* scanner_data_pid_cal_range, DWORD *scanner_data_scale, long* scanner_data_Time,
                          bool* nlc_c_xy, bool* ncl_xy, bool* nlc_c_z, bool* ncl_z,
                          bool* nlc_o_xy, bool* nlc_o_z, float *_free_move_speed,
                          float* scanner2_data_pid_cal_range, DWORD *scanner2_data_scale, long* scanner2_data_Time,
                          bool* nlc2_c_xy, bool* ncl2_xy, bool* nlc2_c_z, bool* ncl2_z,
                          bool* nlc2_o_xy, bool* nlc2_o_z, float *_free_move_speed2);

    void SetExtraCalibOut(double*, double*);

    double* adcCalib;
    double* dacCalib;

    QTimer *boot_timeout_t;
    bool boot_timeout;

signals:
    void xUpdate(double);
    void x2Update(double);
    void yUpdate(double);
    void y2Update(double);
    void zUpdate(double);
    void z2Update(double);

    void sigSetpointError(int);

    void restart_boot_timer();
    void boot_failed();
    void no_firmware();

    void usbStatus(int);
    void updateUsbStatus(bool);
    void Update_EEP_Data(void);
    void sig_Osc_reset();
    void OscCurveData(QByteArray data);

public slots:
    void setDeviceStatus(int);

    void thread_close();

    void Usb_Load_Data(void);
    void Data_to_Cont();
    void Save_to_EEPROM(void);
    void SendExtraCalib();

    void Osc_Start();
    void Osc_Stop();
    void Set_osc_Channel(int, int);

    void Go_to_XYZ(double, double, double);
    void Go_to_XYZ2(double, double, double);
    void Go_to_Zobject(double);
    void Go_to_Xobject(double);
    void Go_to_Yobject(double);

    void s_boot_timeout();
    void sl_csb_speed(int idx);

};

#endif // CONTROL3030_HPP
