#ifndef PMSPLOT__H
#define PMSPLOT__H

#include "mainwindow.h"
#include "controls.h"
#include "edit.hpp"

class IExternalScan;
class PMSPlot;
IExternalScan *getNewPMSIExtScan(PMSPlot *pms);

class PmsController;
class CCDMatrix;
class StatusWidget1;
class PMSPlot : public QWidget
{
    Q_OBJECT

public slots:
    void setDeviceStatus(int);
    void sl_set_X_scale(int sc);

    void setTime(int time);
    void setMacroTime(double time);
    void setCollectTime(double time);
    void setHoldoff(double hoff);
    void setAlvl(double lvl);
    void setBlvl(double lvl);
    void setAgate(double lvl);
    void setBgate(double lvl);
    void setAevnt(double lvl);
    void setBevnt(double lvl);

    void on_MyPl_CurveColourChanged(QColor c, int AC);
    void AddDataToContainer_slot(plot::TCurvesDataOwner, plot::TMetaStorage);
    void AddData(plot::TMetaStorage *lst);

    void StartStop(bool st);
    void ScanStop();
    void ScanTypeChanged(int pos);

signals:
    void AddDataToContainer(plot::TCurvesDataOwner, plot::TMetaStorage);

public:
    PMSPlot(CCDMatrix *ccd, QWidget *parent = 0);
    ~PMSPlot();

    CCDMatrix *ccdmatrix;

    QPointer<StatusWidget1> deviceStatus;
    TwoStateButton *PBToNewWindow;
    plot::T2dPlot *MyPl;
    plot::TCurvesDataOwner curveData;
    plot::TMetaStorage curveCalib;

    PmsController *pmsControl;
    TwoStateButton *BStartStop;
    TwoStateButton *BOpt2;
    int mode;

    Edit *Etime;
    Edit *Emacrotime;
    Edit *Ecollecttime;
    Edit *Eholdoff;

    Edit *EAlvl;
    Edit *EBlvl;
    Edit *EAgate;
    Edit *EBgate;
    Edit *EAevnt;
    Edit *EBevnt;

    Edit *Ewmin;
    Edit *Ewmax;
    QComboBox *CBpoints;
    QComboBox *CBunits;

    QGroupBox *GBOptions;
    QGroupBox *GBOptions2;
    QGroupBox *GBosc;
    QGroupBox *GBspec;

    QLineEdit *avgA;
    QLineEdit *avgB;
    QLineEdit *rmsA;
    QLineEdit *rmsB;
    TRectWidget *LEdColour[2];

    QComboBox *setXYscanMode;

    DoubleChanger *zPos;

    bool _start;
    double _time;
    double _xtime;
    double _currwl;
    double _dwl;

};

#endif //PMSPLOT_H
