#ifndef TEMP_CONTROL_HPP
#define TEMP_CONTROL_HPP

#include <QWidget>
#include <QThread>
#include <QPointer>
#include <plot.h>
#include "edit.hpp"

class StatusWidget1;
class temp_control_loop;
class temp_control : public QWidget
{
    Q_OBJECT
public:
    explicit temp_control(QWidget *parent = 0);
    ~temp_control();

    QPointer<StatusWidget1> deviceStatus;

    temp_control_loop *loop;
    plot::T2dPlot *plot2d;
    plot::TCurvesDataOwner curveData;

    Edit *edP, *edI, *edD, *edTemp;
    QPushButton *Boff, *Bon;
    QLabel *lTemp;
    int T;
    int Tmax;
    Edit *edT;

signals:
    void newPid(double, double, double);

public slots:
    void nativeThermoData(QByteArray data);
    void setDeviceStatus(int);
    void setT();
    void setPid();
    void addTemp(double temp);

};

class temp_control_loop : public QThread
{
    Q_OBJECT
public:
    temp_control_loop();
    void load();
    void run();

signals:
    void status(int);
    void currentTemp(double);

public slots:
    void setTemp(double temp);
    void setPid(double p, double i, double d);
    void startPid();
    void stopPid();

public:
    bool set_pid, set_temp, stop_pid;
    double temp, p, i, d;
    bool shutdown;
};

#endif // TEMP_CONTROL_HPP
