#ifndef MOTORS_HPP
#define MOTORS_HPP

#include <defs.h>
#include <QWidget>
#include <QPointer>
#include "controls.h"
#include "edit.hpp"

class StatusWidget1;
class MotorSlider;
class QVBoxLayout;
class QGroupBox;
class QCheckBox;
class Motors : public QWidget
{
    Q_OBJECT

signals:
    void Motor_data_Leveling(int, unsigned char, double, double);
    void RawMotor_inv_end(unsigned char, unsigned short);

    void m123stopped();

public slots:
    void go(int num, int dir, double speed, double steps); //mkm
    void goUpE(int num = -1, double speed = 0);
    void goUp(int num = -1, double speed = 0, double dist = 0); //mkm
    void goDownE(int num = -1, double speed = 0);
    void goDown(int num = -1, double speed = 0, double dist = 0); //mkm
    void goStop(int num = -1);
    void goShuttleInt(int speedidx, int num = -1); //-5..5, with intra/extrapolation
    void goShuttle(double speedidx, int num = -1); //-5..5, with intra/extrapolation
    void goShuttleStep(int dir, int num = -1); //1/-1

    void init();
    void setBLspeed();
    void Slot_Set_Motor_Status_handler(int,int);
    void Slot_Set_Motor_Status();
    void capBits(int, long);
    void reset();

    void save_params();
    void save_device();
    void save_current();
    void SetCurrent(int num = 1);
    void sett_showhide();

public:
    Motors(QWidget *parent = 0);

    Edit *Enum;
    QPushButton *PBselector[16];
    int active_motor;
    int last_command;

    Edit *Espeed;
    Edit *Edist;

    QPushButton *BShowHideSett;
    QWidget *Wsettings;
    QPushButton *BSave;
    QGroupBox *WsettGB;
    QLineEdit *LEname;
    Edit *Eidx;
    QCheckBox *CBinv;
    QCheckBox *CBdir;
    Edit *EBLdist; //backlash

    Edit *Ecsbmotors;
    Edit *Epitch;
    Edit *Estepsrev;
    Edit *EBLspeed; //backlash
    bool orient123;
    bool orient[16];

    QWidget *WsettingsShuttle;
    Edit *EdistShuttle;
    Edit *EspeedShuttle[5+1];

    QPointer<StatusWidget1> SWmotor1;
    QTimer *motorSync;
    BYTE Motor[8];
    bool Motor_on[8];
    int motorStatusLimit;

    bool blocksave;
    bool reqsent;
};

#endif // MOTORS_HPP
